//===-- temu-c/GdbServer.h - GdbServer API ------------------------*- C++ -*-===//
//
// T-EMU: The Terma Emulator
// (c) Terma 2015
// Authors: Mattias Holm <maho@terma.com>
//
//===----------------------------------------------------------------------===//

#ifndef TEMU_GDBSERVER_H
#define TEMU_GDBSERVER_H

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif
/// \brief Initialise the GDB Server Library
void temu_initGdbServerLib(void);

/// Create a new GDB server
void* temu_createGdbServer(uint16_t Port);

/// Dispose a GDB server
void temu_disposeGdbServer(void *Gdb);

/// Wait current thread for a user to connect
void temu_gdbWaitForConnection(void *Gdb);

/// Add named machine to GDB server
void temu_gdbAddMachine(void *Gdb, const char *MachineName);

/// Add named CPU to GDB server
void temu_gdbAddCpu(void *Gdb, const char *CpuName);

/// Tell GDB server to stop at next safe point in time.
void temu_gdbAsyncStop(void *Gdb);

/// Run the GDB server loop
int temu_gdbRun(void *Gdb);

#ifdef __cplusplus
}
#endif


#endif /* TEMU_GDBSERVER_H */
